#ifndef lint
static char *sccsid = "@(#)xcal_help.c	3.6 (Hillside Systems) 1/16/91";
static char *copyright = "@(#)Copyright 1989,1990 Peter Collinson, Hillside Systems";
#endif  /* lint */
/***

* module name:
	xcal_help.c
* function:
	Generate help screens in separate popup windows
* history:
	Written December 1989
	Peter Collinson
	Hillside Systems
* (C) Copyright: 1989 Hillside Systems/Peter Collinson
	
	For full permissions and copyright notice - see xcal.c
***/
#include <stdio.h>
#include <ctype.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#if defined XI18N && ProjectX == 5
#include <X11/wchar.h>
#endif
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#if defined XI18N && ProjectX == 5
#include <X11/Xaw/CommandLc.h>
#else
#include <X11/Xaw/Command.h>
#endif
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include "xcal.h"

static XtCallbackRec callbacks[] = {
   {NULL,NULL},
   {NULL,NULL}
};

void	addversion();

void
DisplayHelpWindow(str)
	String	str;
{
	Widget		shell, form, title;
	Arg		args[10];
	Cardinal	nargs;
	void		DestroyHelp();
	
	shell = XtCreatePopupShell("help", topLevelShellWidgetClass, toplevel, NULL, 0);

	form =  XtCreateManagedWidget("helpPanel", panedWidgetClass, shell, NULL, 0);

	nargs = 0;
	XtSetArg(args[nargs], XtNshowGrip, False); nargs++;
	XtSetArg(args[nargs], XtNdefaultDistance, 2); nargs++;
	title = XtCreateManagedWidget("helpForm", formWidgetClass, form, args, nargs);
	/*
	 *	Exit button
	 *	Take "Quit" from resources
	 */
	callbacks[0].callback = DestroyHelp;
	callbacks[0].closure = (caddr_t)shell;
	nargs = 0;
	XtSetArg(args[nargs], XtNcallback, callbacks); nargs++;
	XtSetArg(args[nargs], XtNfromHoriz, NULL); nargs++;
	XtSetArg(args[nargs], XtNleft, XtChainLeft); nargs++;
	XtSetArg(args[nargs], XtNright, XtChainLeft); nargs++;
#ifdef XI18N
	(void) XtCreateManagedWidget("helpQuit", commandLocaleWidgetClass, title, args, nargs);
#else
	(void) XtCreateManagedWidget("helpQuit", commandWidgetClass, title, args, nargs);
#endif
	/*
	 *	Now the text
	 *	which is the remainder of the panel
	 */
	nargs = 0;
	XtSetArg(args[nargs], XtNshowGrip, False); nargs++;
	XtSetArg(args[nargs], XtNstring, str); nargs++;
	XtSetArg(args[nargs], XtNdisplayCaret, False); nargs++;
	(void) XtCreateManagedWidget("helpText", asciiTextWidgetClass, form, args, nargs);

	XtPopup(shell, XtGrabNone);
	XtFree(str);
}

/* ARGSUSED */
void
DestroyHelp(w, closure, call_data)
	Widget	w;
	caddr_t	closure;
	caddr_t call_data;
{
	XtDestroyWidget((Widget)closure);
}

String GetHelpString(head)
	char	*head;
{
	String 	buf;
	String 	bp;
	FILE	*fp;
	int	instr = 0, headlen;
	extern char version[];
	extern char patchlevel[];

	buf = (String) XtMalloc(2048);
	*buf = '\0';
	bp = buf;

	headlen = strlen(head);
	if((fp = fopen(appResources.helpfile, "r"))==NULL) {
		XBell(XtDisplay(toplevel), 0);
		fprintf(stderr, "xcal: %s: Could not open help file.\n",
			appResources.helpfile);
		perror("xcal: open");
		fflush(stderr);
		return buf;
	}
	while(fgets(bp, BUFSIZ, fp)!=NULL) {
		if (instr) {
			if (*bp == '#') break;
			bp += strlen(bp);
		}
		else {
			if (*bp == '#'
			    && strncmp(bp+1, head, headlen)==0)
				instr = 1;
		}
	}
	close(fp);

	sprintf(bp, "%s,\nPatch Level %s\n", version, patchlevel);

	return buf;
}

/* ARGSUSED */
void
StripHelp(w, closure, call_data)
	Widget w;
	caddr_t	closure;
	caddr_t call_data;
{
	DisplayHelpWindow(GetHelpString("STRIP"));
}
	

/* ARGSUSED */
void
EditHelp(w, closure, call_data)
	Widget w;
	caddr_t	closure;
	caddr_t call_data;
{
	DisplayHelpWindow(GetHelpString("EDIT"));
}
	
/* ARGSUSED */
void
MemoHelp(w, closure, call_data)
	Widget w;
	caddr_t	closure;
	caddr_t call_data;
{
	DisplayHelpWindow(GetHelpString("MEMO"));
}

/* ARGSUSED */
void
WeeklyHelp(w, closure, call_data)
	Widget w;
	caddr_t	closure;
	caddr_t call_data;
{
	DisplayHelpWindow(GetHelpString("WEEKLY"));
}
